/*
 * BUGBUG: have to port this mess to Solaris ....
 */

#include <stdio.h>
#include <string.h>
#ifdef	__BSD__
#include <stdlib.h>
#else
#include <malloc.h>
#endif	/* __BSD__ */

#include "nanoglut.h"

static ui_event_t *message_queue = NULL;

static event_class_t
peek_next_event(int *scan_ret, int *char_ret, int *px_ret, int *py_ret)
{
	event_class_t retval;
	struct ui_event_s *ev;
	if (!message_queue)
		return no_event;
	/* remove tail */
	ev = message_queue->prev;
	if (ev->next == ev)
		message_queue = NULL;
	else {
		ev->prev->next = message_queue;
		message_queue->prev = ev->prev;
	}
	if (scan_ret)
		*scan_ret = ev->scan_code;
	if (char_ret)
		*char_ret = ev->char_code;
	if (px_ret)
		*px_ret = ev->pointer_x;
	if (py_ret)
		*py_ret = ev->pointer_y;
	retval = ev->event_class;
	free(ev);
	return retval;
}

static void
push_event(event_class_t event_class, int scan_code, int char_code,
	   int pointer_x, int pointer_y)
{
	struct ui_event_s *ev;
	ev = (struct ui_event_s *)calloc(1, sizeof(struct ui_event_s));
	ev->event_class = event_class;
	ev->scan_code = scan_code;
	ev->char_code = char_code;
	ev->pointer_x = pointer_x;
	ev->pointer_y = pointer_y;
	if (!message_queue) {
		message_queue = ev->next = ev->prev = ev;
		return;
	}
	/* append to head */
	ev->prev = message_queue->prev;
	ev->next = message_queue;
	message_queue->prev->next = ev;
	message_queue->prev = ev;
	message_queue = ev;
}

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Platform-dependent part
 */

#ifdef	__WIN32__

#include <windows.h>
#include "GL/gl.h"

static WNDCLASS	wc;
static HWND		wnd = NULL;
static HDC			drawable = NULL;
static HGLRC		gl_drawable = NULL;
static int			vidmode_changed = 0;

/*
 * ref_shutdown()
 */
void
ref_shutdown(void)
{
	if (vidmode_changed) {
		ChangeDisplaySettings(NULL, 0);
		vidmode_changed = 0;
	}
	if (gl_drawable) {
		wglMakeCurrent(NULL, NULL);
		wglDeleteContext(gl_drawable);
		gl_drawable = NULL;
	}
	if (drawable)
		ReleaseDC(wnd, drawable);
	drawable = NULL;
	if (wnd)
		DestroyWindow(wnd);
	wnd = NULL;
	UnregisterClass(wc.lpszClassName, wc.hInstance);
}

/*
 * ref_init()
 */
LRESULT CALLBACK
gl_window_proc(HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam);

int
ref_init(char *caption, int width, int height, int fullscreen,
	int need_depth, int need_stencil, int need_dst_alpha)
{
	HDC refdc;
	static char *class_name = "mgl_wnd_class"; /* fixme ??? */
	int pixfmt, screen_width, screen_height, screen_bpp, screen_refresh;
	PIXELFORMATDESCRIPTOR pfd;
	refdc = GetDC(NULL);
	screen_bpp = GetDeviceCaps(refdc, BITSPIXEL);
	screen_refresh = GetDeviceCaps(refdc, VREFRESH);
	ReleaseDC(NULL, refdc);
	if (!fullscreen && (screen_bpp <= 8)) {
		MessageBox(NULL, "At least 32K - color mode required.",
			"Insufficient number of colors", MB_ICONEXCLAMATION);
	}
	ZeroMemory(&wc, sizeof(wc));
	wc.lpszClassName = class_name;
	wc.hInstance = GetModuleHandle(NULL);
	wc.style = CS_CLASSDC | CS_NOCLOSE;
	wc.lpfnWndProc = gl_window_proc;
	wc.hIcon = LoadIcon(NULL, IDI_WINLOGO);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = GetStockObject(HOLLOW_BRUSH);
	wc.lpszMenuName = NULL;
	if (!RegisterClass(&wc)) {
		MessageBox(NULL, "RegisterClass() failed.", "ref_init()",
			MB_ICONHAND);
		return 0;
	}
	if (fullscreen) {
		wnd = CreateWindow(class_name, caption,
				   WS_POPUP,
				   0, 0,
				   width,
				   height,
				   NULL, NULL, wc.hInstance, NULL);
	} else {
		int cxf = GetSystemMetrics(SM_CXFIXEDFRAME);
		int cyf = GetSystemMetrics(SM_CYFIXEDFRAME);
		int cyc = GetSystemMetrics(SM_CYCAPTION);
		wnd = CreateWindow(class_name, caption,
				   WS_POPUP | WS_CAPTION,
				   0, 0, width + 2 * cxf, height + 2 * cyf + cyc,
				   NULL, NULL, wc.hInstance, NULL);
	}
	if (!wnd) {
		MessageBox(NULL, "CreateWindow() failed.", "ref_init()",
			MB_ICONHAND);
		ref_shutdown();
		return 0;
	}
	drawable = GetDC(wnd);
	ShowWindow(wnd, SW_SHOWNORMAL);
	while (fullscreen) {
		DEVMODE 	dm;
		OSVERSIONINFO	ovi;
		screen_width = GetSystemMetrics(SM_CXSCREEN);
		screen_height = GetSystemMetrics(SM_CYSCREEN);
		if (screen_width == width && screen_height == height && screen_bpp > 8)
			break;
		if (screen_width < width || screen_height < height)
			screen_refresh = 60;
		ZeroMemory(&dm, sizeof(dm));
		dm.dmSize = sizeof(dm);
		dm.dmPelsWidth = width;
		dm.dmPelsHeight = height;
		dm.dmBitsPerPel = (screen_bpp > 8) ? screen_bpp : 32;
		dm.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT | DM_BITSPERPEL;
		ZeroMemory(&ovi, sizeof(ovi));
		ovi.dwOSVersionInfoSize = sizeof(ovi);
		GetVersionEx(&ovi);
		if (ovi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
			/* NT/2K/XP */
			dm.dmDisplayFrequency = screen_refresh;
			dm.dmFields |= DM_DISPLAYFREQUENCY;
		}
		if (ChangeDisplaySettings(&dm, 0) != DISP_CHANGE_SUCCESSFUL) {
			MessageBox(NULL, "CDS() failed.", "ref_init()",
				MB_ICONHAND);
			ref_shutdown();
			return 0;
		}
		vidmode_changed = 1;
		break;
	}
	PatBlt(drawable, 0, 0, width, height, BLACKNESS);
	ZeroMemory(&pfd, sizeof(pfd));
	pfd.nSize = sizeof(pfd);
	pfd.nVersion = 1;
	pfd.iPixelType = PFD_TYPE_RGBA;
	pfd.iLayerType = PFD_MAIN_PLANE;
	pfd.cColorBits = 16;
    if (need_depth) {
		pfd.cDepthBits = 16;
	}
    if (need_stencil) {
		pfd.cStencilBits = 1;
	}
    if (need_dst_alpha) {
		pfd.cAlphaBits = 1;
	}
	pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_DOUBLEBUFFER
		| PFD_SUPPORT_OPENGL;
	pfd.iPixelType = PFD_TYPE_RGBA;
	pixfmt = ChoosePixelFormat(drawable, &pfd);
	if (!pixfmt) {
		MessageBox(wnd, "ChoosePixelFormat() failed.", "ref_init()",
			MB_ICONHAND);
		ref_shutdown();
		return 0;
	}
	ZeroMemory(&pfd, sizeof(pfd));
	pfd.nSize = sizeof(pfd);
	DescribePixelFormat(drawable, pixfmt, sizeof(pfd), &pfd);
	if (need_dst_alpha && !pfd.cAlphaBits) {
		MessageBox(wnd, "DescribePixelFormat() no DST alpha.", "ref_init()",
			MB_ICONHAND);
		ref_shutdown();
		return 0;
	}
	if (!SetPixelFormat(drawable, pixfmt, &pfd)) {
		MessageBox(wnd, "SetPixelFormat() failed.", "ref_init()",
			MB_ICONHAND);
		ref_shutdown();
		return 0;
	}
	gl_drawable = wglCreateContext(drawable);
	if (!gl_drawable) {
		MessageBox(wnd, "wglCreateContext() failed.", "ref_init()",
			MB_ICONHAND);
		ref_shutdown();
		return 0;
	}
	if (!wglMakeCurrent(drawable, gl_drawable)) {
		MessageBox(wnd, "wglCreateContext() failed.", "ref_init()",
			MB_ICONHAND);
		wglDeleteContext(gl_drawable);
		ref_shutdown();
		return 0;
	}
	printf("GL_VENDOR\t%s\n", (char*)glGetString(GL_VENDOR));
	printf("GL_RENDERER\t%s\n", (char*)glGetString(GL_RENDERER));
	printf("GL_VERSION\t%s\n", (char*)glGetString(GL_VERSION));
	printf("GL_EXTENSIONS\t%s\n", (char*)glGetString(GL_EXTENSIONS));
	return !0;
}

static int
win32_scan_code(WPARAM wParam, LPARAM lParam)
{
	unsigned char	scan;
	switch (wParam) {
	case VK_ESCAPE:
		return key_escape;
	case VK_RETURN:
		return key_enter;
	}
	scan = (unsigned char)((lParam >> 16) & 0xFF);
	switch (scan) {
	case 72:
		return key_up;
	case 75:
		return key_left;
	case 77:
		return key_right;
	case 80:
		return key_down;
	}
	return key_unknown;
}

static void
win32_pointer_pos(LPARAM lParam, int *px_ret, int *py_ret)
{
	int 	x, y;
	x = LOWORD(lParam);
	y = HIWORD(lParam);
	if (x & 0x8000)
		x |= 0xFFFF0000;
	if (y & 0x8000)
		y |= 0xFFFF0000;
	*px_ret = x;
	*py_ret = y;
}

static void
win32_guess_pointer_pos(int *px_ret, int *py_ret)
{
	POINT		pt;
	GetCursorPos(&pt);
	ScreenToClient(wnd, &pt);
	*px_ret = pt.x;
	*py_ret = pt.y;
}

static void
win32_grab_pointer(int grab)
{
	static int	pointer_grabbed = 0;
	if (grab) {
		if (pointer_grabbed)
			return;
		SetCapture(wnd);
		pointer_grabbed = 1;
	} else {
		if (!pointer_grabbed)
			return;
		pointer_grabbed = 0;
		ReleaseCapture();
	}
}

LRESULT 	CALLBACK
gl_window_proc(HWND wnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	event_class_t	event_class = no_event;
	int 	scan_code = 0, char_code = 0, pointer_x = 0, pointer_y = 0;
	switch (msg) {
	case WM_MOUSEMOVE:
		win32_pointer_pos(lParam, &pointer_x, &pointer_y);
		event_class = pointer_motion_event;
		break;
	case WM_KEYDOWN:
		event_class = key_press_event;
		char_code = wParam;
		scan_code = win32_scan_code(wParam, lParam);
		win32_guess_pointer_pos(&pointer_x, &pointer_y);
		break;
	case WM_KEYUP:
		event_class = key_release_event;
		char_code = wParam;
		scan_code = win32_scan_code(wParam, lParam);
		win32_guess_pointer_pos(&pointer_x, &pointer_y);
		break;
	case WM_LBUTTONDOWN:
		event_class = key_press_event;
		scan_code = key_left_mouse;
		win32_pointer_pos(lParam, &pointer_x, &pointer_y);
		win32_grab_pointer(1);
		break;
	case WM_MBUTTONDOWN:
		event_class = key_press_event;
		scan_code = key_middle_mouse;
		win32_pointer_pos(lParam, &pointer_x, &pointer_y);
		win32_grab_pointer(1);
		break;
	case WM_RBUTTONDOWN:
		event_class = key_press_event;
		scan_code = key_right_mouse;
		win32_pointer_pos(lParam, &pointer_x, &pointer_y);
		win32_grab_pointer(1);
		break;
	case WM_LBUTTONUP:
		event_class = key_release_event;
		scan_code = key_left_mouse;
		win32_pointer_pos(lParam, &pointer_x, &pointer_y);
		win32_grab_pointer(0);
		break;
	case WM_MBUTTONUP:
		event_class = key_release_event;
		scan_code = key_middle_mouse;
		win32_pointer_pos(lParam, &pointer_x, &pointer_y);
		win32_grab_pointer(0);
		break;
	case WM_RBUTTONUP:
		event_class = key_release_event;
		scan_code = key_right_mouse;
		win32_pointer_pos(lParam, &pointer_x, &pointer_y);
		win32_grab_pointer(0);
		break;
	case WM_PAINT:
		BeginPaint(wnd, &ps);
		EndPaint(wnd, &ps);
		break;
	default:
		break;
	}
	if (event_class != no_event) {
		push_event(event_class, scan_code, char_code, pointer_x, pointer_y);
		return 0;
	}
	return DefWindowProc(wnd, msg, wParam, lParam);
}

event_class_t
ref_next_event(int *scan_ret, int *char_ret, int *px_ret, int *py_ret)
{
	MSG 	msg;
	while (PeekMessage(&msg, wnd, 0, 0, PM_REMOVE)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return peek_next_event(scan_ret, char_ret, px_ret, py_ret);
}

void
ref_end_frame(void)
{
	SwapBuffers(drawable);
}

void
ref_delay(int ms)
{
	Sleep(ms);
}

#else

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Lett's assume some UN*X + X11 + GLX
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include "GL/gl.h"
#include <GL/glx.h>
#ifdef	__BSD__
#include <unistd.h> /* for select() */
#else
#include <sys/select.h>
#endif	/* __BSD__ */
#include <sys/time.h>
#include <sys/types.h>

/*
 * Uncomment to use XFree86 VidMode extension
#define	HAVE_XF86_VIDMODE
 */

#ifdef	HAVE_XF86_VIDMODE
#include <X11/extensions/xf86vmode.h>
#endif	/* HAVE_XF86_VIDMODE */

Display 	*dpy;
int 		scrnum;
Window		root, wnd;
int 		wnd_focused = 0;
XVisualInfo *visinfo;
GLXContext	gl_drawable;
XSetWindowAttributes attr;

#ifdef	HAVE_XF86_VIDMODE

XF86VidModeModeInfo **vidmodes = NULL;
int 	num_vidmodes = 0;
int 	vidmode_changed = 0;

int
X11_set_video_mode(int width, int height)
{
	int mj = 0, mn = 0;
	int sw, sh, i;
	sw = WidthOfScreen(DefaultScreenOfDisplay(dpy));
	sh = HeightOfScreen(DefaultScreenOfDisplay(dpy));
	if (width == sw && height == sh)
		return !0;
	if (!vidmodes) {
		if (!XF86VidModeQueryVersion(dpy, &mj, &mn)) {
			fprintf(stderr, "XFree86-VidModeExtension not found.\n");
			return 0;
		}
		printf("found XFree86-VidModeExtension (version %d.%d).\n", mj, mn);
		XF86VidModeGetAllModeLines(dpy, scrnum, &num_vidmodes, &vidmodes);
		if (!vidmodes) { /* just a safety measure, though... */
			fprintf(stderr, "XF86VidModeGetAllModeLines() failed !.\n");
			return 0;
		}
	}
	for (i = 0; i < num_vidmodes; i++) {
		if (width == vidmodes[i]->hdisplay &&
			height == vidmodes[i]->vdisplay)
			break;
	}
	if (i == num_vidmodes) {
		fprintf(stderr, "Unable to find mode '%i X %i'.\n", width, height);
		return 0;
	}
	XWarpPointer(dpy, None, wnd, 0, 0, 0, 0, width >> 1, height >> 1);
	XF86VidModeSwitchToMode(dpy, scrnum, vidmodes[i]);
	XF86VidModeSetViewPort(dpy, scrnum, 0, 0);
	/* TODO: viewport locking (but _how_? - have to look to Q code ?) */
	vidmode_changed = 1;
	return !0;
}

void
X11_restore_video_mode(void)
{
	int i;
	if (!vidmodes)
		return;
	if (vidmode_changed) {
		XF86VidModeSwitchToMode(dpy, scrnum, vidmodes[0]);
		vidmode_changed = 0;
	}
	for (i = 0; i < num_vidmodes; i++) {
		if (vidmodes[0]->privsize)
#if defined(__cplusplus) || defined(c_plusplus)
			XFree(vidmodes[0]->c_private);
#else
			XFree(vidmodes[0]->private);
#endif
	}
	XFree(vidmodes);
	vidmodes = NULL;
}

#else	/* !HAVE_XF86_VIDMODE */

int
X11_set_video_mode(int width, int height)
{
	return 0;
}

void
X11_restore_video_mode(void)
{
	return;
}

#endif	/* !HAVE_XF86_VIDMODE */

/*
 * ref_shutdown()
 */
void
ref_shutdown(void)
{
	if (gl_drawable) {
		glXMakeCurrent(dpy, None, NULL);
		glXDestroyContext(dpy, gl_drawable);
		gl_drawable = NULL;
	}
	if (wnd) {
		XDestroyWindow(dpy, wnd);
		wnd = 0;
	}
	if (visinfo) {
		XFree(visinfo);
		visinfo = NULL;
	}
	X11_restore_video_mode();
	if (dpy) {
		XCloseDisplay(dpy);
		dpy = NULL;
	}
}

/*
 * ref_init()
 */
int
ref_init(char *caption, int width, int height, int fullscreen,
	int need_depth, int need_stencil, int need_dst_alpha)
{
	int 	visinfo_class;
	int 	attrib[64], *aptr = attrib;
	unsigned long	mask;
	XSizeHints	sh;
	dpy = XOpenDisplay(NULL);
	if (!dpy) {
		fprintf(stderr, "XOpenDisplay() failed.\n");
		return 0;
	}
	scrnum = DefaultScreen(dpy);
	root = RootWindow(dpy, scrnum);
	*aptr++ = GLX_RGBA;
	*aptr++ = GLX_DOUBLEBUFFER;
	*aptr++ = GLX_RED_SIZE;
	*aptr++ = 1;
	*aptr++ = GLX_GREEN_SIZE;
	*aptr++ = 1;
	*aptr++ = GLX_BLUE_SIZE;
	*aptr++ = 1;
	*aptr = None;
	if (need_depth) {
		*aptr++ = GLX_DEPTH_SIZE;
		*aptr++ = 1;
		*aptr = None;
	}
	if (need_stencil) {
		*aptr++ = GLX_STENCIL_SIZE;
		*aptr++ = 1;
		*aptr = None;
	}
	if (need_dst_alpha) {
		*aptr++ = GLX_ALPHA_SIZE;
		*aptr++ = 1;
		*aptr = None;
	}
	visinfo = glXChooseVisual(dpy, scrnum, attrib);
	if (!visinfo) {
		fprintf(stderr, "glXChooseVisual() failed.\n"
			"Possible reason: requested FB capabilities not supported.\n");
		ref_shutdown();
		return 0;
	}
#if defined(__cplusplus) || defined(c_plusplus)
	visinfo_class = visinfo->c_class;
#else
	visinfo_class = visinfo->class;
#endif
	if (visinfo_class != DirectColor && visinfo_class != TrueColor)
		fprintf(stderr, "WARNING: DirectColor or TrueColor visual required.\n");
	attr.background_pixmap = None;
	attr.border_pixel = None;
	attr.colormap = XCreateColormap(dpy, root, visinfo->visual, AllocNone);
	attr.event_mask = StructureNotifyMask | ExposureMask
		| KeyPressMask | KeyReleaseMask | KeymapStateMask
		| ButtonPressMask | ButtonReleaseMask | PointerMotionMask
		| ButtonMotionMask | VisibilityChangeMask | FocusChangeMask
		| EnterWindowMask | LeaveWindowMask;
	attr.background_pixel = None;
	attr.backing_store = NotUseful;
	attr.save_under = False;
	mask = CWBackPixmap | CWBorderPixel | CWColormap | CWEventMask |
		CWBackPixel | CWBackingStore | CWSaveUnder;
	if (fullscreen) {
		mask |= CWOverrideRedirect;
		attr.override_redirect = True;
	}
	if (width == 0)
		width = DisplayWidth(dpy, scrnum);
	if (height == 0)
		height = DisplayHeight(dpy, scrnum);
	wnd = XCreateWindow(dpy, root, 0, 0, width, height, 0,
				visinfo->depth, InputOutput,
				visinfo->visual,
				mask, &attr);
	if (!wnd) {
		fprintf(stderr, "XCreateWindow() failed.\n");
		ref_shutdown();
		return 0;
	}
	XStoreName(dpy, wnd, caption);
	memset(&sh, 0, sizeof(sh));
	sh.flags = USPosition | USSize | PPosition | PSize | \
		PMinSize | PMaxSize | PBaseSize;
	sh.x = 0;
	sh.y = 0;
	sh.width = sh.min_width = sh.max_width = sh.base_width = width;
	sh.height = sh.min_height = sh.max_height = sh.base_height = height;
	XSetWMNormalHints(dpy, wnd, &sh);
	XSetWindowBackgroundPixmap(dpy, wnd, None);
	XMapWindow(dpy, wnd);
	XRaiseWindow(dpy, wnd);
	if (fullscreen)
		XSetInputFocus(dpy, wnd, RevertToParent, CurrentTime);
	gl_drawable = glXCreateContext(dpy, visinfo, NULL, True);
	if (!gl_drawable) {
		fprintf(stderr, "glXCreateContext() failed.\n");
		ref_shutdown();
		return 0;
	}
	glXMakeCurrent(dpy, wnd, gl_drawable);
	if (fullscreen && !X11_set_video_mode(width, height)) {
		fprintf(stderr, "WARNING: Unable to change screen resolution.\n");
	}
	printf("GL_VENDOR\t%s\n", glGetString(GL_VENDOR));
	printf("GL_RENDERER\t%s\n", glGetString(GL_RENDERER));
	printf("GL_VERSION\t%s\n", glGetString(GL_VERSION));
	printf("GL_EXTENSIONS:\t\n");
	puts((char*)glGetString(GL_EXTENSIONS));
	return !0;
}

int
X11_scan_code(XEvent * event, int *char_ret)
{
	char		buf[64];
	KeySym		keysym;
	if (XLookupString(&event->xkey, buf, sizeof(buf), &keysym, 0) == 1)
		*char_ret = buf[0];
	else
		*char_ret = 0;
	switch (keysym) {
	case XK_Escape:
		return key_escape;
	case XK_KP_Enter:
	case XK_Return:
		return key_enter;
	case XK_Left:
		return key_left;
	case XK_Right:
		return key_right;
	case XK_Down:
		return key_down;
	case XK_Up:
		return key_up;
	default:
		break;
	}
	return key_unknown;
}

int
X11_button_code(XEvent * event)
{
	switch (event->xbutton.button) {
		case Button1:return key_left_mouse;
	case Button2:
		return key_middle_mouse;
	case Button3:
		return key_right_mouse;
	default:
		break;
	}
	return key_unknown;
}

void
X11_grab_pointer(int grab)
{
	static int pointer_grabbed = 0;
	if (grab) {
		if (pointer_grabbed)
			return;
		XGrabPointer(dpy, wnd, True, 0,
				 GrabModeAsync, GrabModeAsync, wnd,
				 None, CurrentTime);
		pointer_grabbed = 1;
	} else {
		if (!pointer_grabbed)
			return;
		pointer_grabbed = 0;
		XUngrabPointer(dpy, CurrentTime);
	}
}

void
X11_process_message(XEvent * event)
{
	int scan_code = 0, char_code = 0;
	event_class_t event_class;
	switch (event->type) {
	case FocusOut:
		wnd_focused = 0;
		return;
	case FocusIn:
		wnd_focused = 1;
		return;
	case KeyPress:
		event_class = key_press_event;
		scan_code = X11_scan_code(event, &char_code);
		break;
	case KeyRelease:
		event_class = key_release_event;
		scan_code = X11_scan_code(event, &char_code);
		break;
	case MotionNotify:
		if (!wnd_focused)
			return;
		event_class = pointer_motion_event;
		scan_code = char_code = 0;
		break;
	case ButtonPress:
		event_class = key_press_event;
		scan_code = X11_button_code(event);
		char_code = 0;
		break;
	case ButtonRelease:
		event_class = key_release_event;
		scan_code = X11_button_code(event);
		char_code = 0;
		break;
	default:
		return;
	}
	push_event(event_class, scan_code, char_code, event->xmotion.x, event->xmotion.y);
}

event_class_t
ref_next_event(int *scan_ret, int *char_ret, int *px_ret, int *py_ret)
{
	XEvent event;
	while (XPending(dpy)) {
		XNextEvent(dpy, &event);
		X11_process_message(&event);
	}
	return peek_next_event(scan_ret, char_ret, px_ret, py_ret);
}

void
ref_end_frame(void)
{
	glXSwapBuffers(dpy, wnd);
}

void
ref_delay(int ms)
{
	/*
	 * The straightforward way is to use usleep(), but there are some
	 * bizzare problems with headers (even) on modern Linux
	 * distrubutions.
	 * And: this approach also works under FreeBSD.
     * The idea is _not_ mine; actually, it's quite old...
	 */
	struct timeval	delay;
	delay.tv_sec = ms / 1000;
	delay.tv_usec = 1000 * (ms % 1000);
	select(0, NULL, NULL, NULL, &delay);
}

#endif /* !__WIN32__ */
