/* Known events: event->event_class */
typedef enum
{
	no_event,
	key_press_event,
	key_release_event,
	pointer_motion_event
}	event_class_t;

/* Known scancodes: event->scan_code */
enum
{
	key_unknown,
	key_escape,
	key_enter,
	key_up,
	key_left,
	key_right,
	key_down,
	key_left_mouse,
	key_middle_mouse,
	key_right_mouse
};

typedef struct ui_event_s
{
	struct ui_event_s *next, *prev;
	event_class_t	event_class;
	int 	scan_code;
	int 	char_code;
	int 	pointer_x;
	int 	pointer_y;
}	ui_event_t, *ui_event_p;

void ref_shutdown(void);
int ref_init(char *caption, int width, int height, int fullscreen,int need_depth, int need_stencil, int need_dst_alpha);
event_class_t ref_next_event(int *scan_ret, int *char_ret, int *px_ret, int *py_ret);
void ref_end_frame(void);
void ref_delay(int ms);
